import java.util.Hashtable;
import java.util.logging.Logger;

public class AnyBeam extends Plugin {
	private static Logger a = Logger.getLogger("Minecraft");
	private Listener listener = new Listener();

	public class Listener extends PluginListener {
		Hashtable cannons = new Hashtable();
		int size = 3;
		int noho = 0;
		int beamType = 46;
		int borderType = 57;

		public boolean onCommand(Player player, String[] split) {
			if (!player.canUseCommand(split[0]))
				return false;
			if (split[0].equalsIgnoreCase("/AnyBeam")) {
				if (cannons.containsKey(player.getName())) {
					player.sendMessage("AnyBeam safely disabled.");
					cannons.remove(player.getName());
				} else {

					if (split.length > 1){
						try {
						size = Integer.parseInt(split[1]);
						noho = Integer.parseInt(split[2]);
						beamType = Integer.parseInt(split[3]);
						borderType = Integer.parseInt(split[4]);
					} catch (NumberFormatException nfe) {
						size = 3;
						noho = 0;
						beamType = 46;
						borderType = 57;
						player.sendMessage("Usage: /AnyBeam size makehole[1=no] beamID borderID");
					} 
					}
					if (size < 1)
						size = 1;
					
					//*********************
					//From: http://github.com/bootswithdefer/boots-plugins/blob/master/Tips/Tips.java
				      String message1 = Colors.Gray + "Warning: " + Colors.Red + player.getName() + Colors.Gray + " Loaded AnyBeam";
				      String message2 = Colors.Gray + "Size: " + size;
				      if (noho == 0){
							message2 += ", Bedrock, ";
						} else {
							message2 += " , Variable, ";
						}
							message2 += "Beam: " + beamType + ", Border: " + borderType;
				      for (Player p : etc.getServer().getPlayerList()) {
				         if ((p != null ) && (p.getName() != player.getName())) {
				            p.sendMessage(message1);
				            if (p.isAdmin()) {
				            	p.sendMessage(message2);
				            }
				         }
				      }
					//*********************
				      
		            player.sendMessage(" :: WARNING :: ANYBEAM LOADED");
					player.sendMessage(" :: WARNING :: BEAM SIZE: " + size);
					if (noho == 0){
						player.sendMessage(" :: WARNING :: GROUND PENETRATING");
					} else {
						player.sendMessage(" ::  ALERT  :: VARIABLE BEAM LENGTH");
					}
					player.sendMessage(" ::  ALERT  :: BEAM BLOCK ID: " + beamType);
					player.sendMessage(" ::  ALERT  :: BORDER BLOCK ID: " + borderType);
					
					cannons.put(player.getName(), size);
				}
				return true;
			}
			return false;
		}

		private void placePoints(int cx, int cz, int x, int z, int y,
				int blockType) {
			if (x == 0) {
				// Draw the arms
				etc.getServer().setBlockAt(blockType, cx, y, cz + z);
				etc.getServer().setBlockAt(blockType, cx, y, cz - z);
				etc.getServer().setBlockAt(blockType, cx + z, y, cz);
				etc.getServer().setBlockAt(blockType, cx - z, y, cz);
			} else if (x == z) {
				etc.getServer().setBlockAt(blockType, cx + x, y, cz + z);
				etc.getServer().setBlockAt(blockType, cx - x, y, cz + z);
				etc.getServer().setBlockAt(blockType, cx + x, y, cz - z);
				etc.getServer().setBlockAt(blockType, cx - x, y, cz - z);
			} else if (x < z) {
				etc.getServer().setBlockAt(blockType, cx + x, y, cz + z);
				etc.getServer().setBlockAt(blockType, cx - x, y, cz + z);
				etc.getServer().setBlockAt(blockType, cx + x, y, cz - z);
				etc.getServer().setBlockAt(blockType, cx - x, y, cz - z);
				etc.getServer().setBlockAt(blockType, cx + z, y, cz + x);
				etc.getServer().setBlockAt(blockType, cx - z, y, cz + x);
				etc.getServer().setBlockAt(blockType, cx + z, y, cz - x);
				etc.getServer().setBlockAt(blockType, cx - z, y, cz - x);
			}
		}

		public void circleMidpoint(int xCenter, int yCenter, int radius, int y,
				int blockType) {
			int x = 0;
			int z = radius;
			int p = (5 - radius * 4) / 4;
			if (z == 2)
				p--;
			for (int i = z; i >= 0; --i)
				placePoints(xCenter, yCenter, x, i, y, blockType);
			while (x < z) {
				x++;
				if (p < 0) {
					p += 2 * x + 1;
				} else {
					z--;
					p += 2 * (x - z) + 1;
				}
				for (int i = z; i >= 0; --i)
					placePoints(xCenter, yCenter, x, i, y, blockType);
			}
		}

		public void onArmSwing(Player player) {
			// If holding a block, left click to place anywhere!
			if ((player.canUseCommand("/AnyBeam"))
					&& (cannons.containsKey(player.getName()))) {
				a.info("AnyBeam " + player.getName() + " " + size + " " + noho + " " + beamType + " " + borderType);
				HitBlox blox = new HitBlox(player);
				Block block = blox.getTargetBlock();
				if (block == null)
					return;
				if (noho != 0){
					noho = (block.getY() - 1);
				}
				int size = ((Integer) cannons.get(player.getName())).intValue();
				cannons.remove(player.getName());
				// int beamType = 1;
				// int i = block.getY();
				for (int i = 128; i > noho; i--) {
					circleMidpoint(block.getX(), block.getZ(), size, i,
							borderType);
					circleMidpoint(block.getX(), block.getZ(), size - 1, i,
							beamType);
				}
				etc.getServer().setBlockAt(51, block.getX(), 127, block.getZ());
				if ((borderType == 46) || (beamType == 46))
					player.sendMessage("BOOM");
			}
		}
	}

	public void initialize() {
		etc.getLoader().addListener(PluginLoader.Hook.ARM_SWING, listener,
				this, PluginListener.Priority.MEDIUM);
		etc.getLoader().addListener(PluginLoader.Hook.COMMAND, listener, this,
				PluginListener.Priority.MEDIUM);
	}

	public void enable() {
		a.info("AnyBeam v0.1 Enabled");
	}

	public void disable() {
		a.info("AnyBeam v0.1 Disabled");
	}
}
